/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The RestConstants model module.
     * @module constant/RestConstants
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>RestConstants</code>.
     * @alias module:constants/RestConstants
     * @class
     */
    var exports = Object.freeze({
        CONTENT_TYPE_JSON: 'application/json',
        SECURE_HTTP_PROTOCOL: 'https',

        PRODUCTION_API_END_POINT: 'https://api.orbipay.com/payments/v1',
        SANDBOX_API_END_POINT: 'https://sbapi.orbipay.com/payments/v1',
        BASE_PATH: '/payments/v1',
        ENCODING_FORMAT: 'base64',

        ERROR_TECH_DIFFICULTIES_CODE: 'error_tech_difficulties',
        ERROR_TECH_DIFFICULTIES_MESSAGE: 'There is a problem processing this request due to technical difficulties.',
        ERROR_TECH_DIFFICULTIES_APP_ERROR_CODE: '100',

        ERROR_FIELD_CODE: 'error_field',
        ERROR_FIELD_MESSAGE: 'The exception returned if a mandatory field is missing value or if the value is invalid. This is accompanied by the field that caused the exception.',

        CLIENT_SIDE_FIELD_VALIDATION_FAILURE_MESSAGE: 'Client side field validations failed. Please check you request and try again.',
        CLIENT_SIDE_ERROR_MESSAGE: 'Error occurred in client SDK. ',

        ORBIPAY_HASHING_ALGORITHM: 'OPAY1-HMAC-SHA256',
        USER_AGENT: 'Swagger-Codegen/1.0.0/node',
        HASHING_ALGORITHM: 'sha256',

        OS_NAME: 'os.name',
        OS_VERSION: 'os.version',
        OS_ARCH: 'os.arch',
        JAVA_VERSION: 'java.version',
        JAVA_VM_NAME: 'java.vm.name',
        JAVA_RUNTIME_VERSION: 'java.runtime.version',
        IMPLEMENTATION_VERSION: 'Implementation-Version',
        IMPLEMENTATION_TITLE: 'Implementation-Title',
        BUILD_TIME: 'Build-time',
        REVISION: 'Revision',
        BUILD_PROPERTY_FILE_NAME: 'orbipay-paymentsapi-client_old-build_info.properties',

        TIME_STAMP_FORMAT: 'Y-m-d\ H:i:s.vP',
        DATE_FORMAT: 'Y-m-d',
        CURRENT_TIME: 'now',
        RESPONSE_CODES_DELIMITER: ',',
        LOCALE_DELIMITER: '_'
    });

    return exports;
}));
