/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The FundingAccountSubtypeEnum enum module.
     * @module enum/FundingAccountSubtypeEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>account_subtype</code> property.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "savings"
         * @const
         */
        "savings": "savings",
        /**
         * value: "checking"
         * @const
         */
        "checking": "checking",
        /**
         * value: "money_market"
         * @const
         */
        "money_market": "money_market",
        /**
         * value: "visa_credit"
         * @const
         */
        "visa_credit": "visa_credit",
        /**
         * value: "mastercard_credit"
         * @const
         */
        "mastercard_credit": "mastercard_credit",
        /**
         * value: "american_express_credit"
         * @const
         */
        "american_express_credit": "american_express_credit",
        /**
         * value: "discover_credit"
         * @const
         */
        "discover_credit": "discover_credit",
        /**
         * value: "visa_debit"
         * @const
         */
        "visa_debit": "visa_debit",
        /**
         * value: "mastercard_debit"
         * @const
         */
        "mastercard_debit": "mastercard_debit",
        /**
         * value: "discover_debit"
         * @const
         */
        "discover_debit": "discover_debit"
    });

    return exports;
}));