/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The InvocationModeEnum enum module.
     * @module enum/InvocationModeEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>invocation_mode</code> property.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "live" for production
         * @const
         */
        "live": "live",
        /**
         * value: "sandbox" for sandbox
         * @const
         */
        "sandbox": "sandbox",
        /**
         * value: "test" for development. (Plase provide "api_end_point" in this case.)
         * @const
         */
        "test": "test"
    });

    return exports;
}));