/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The PaymentAmountTypeEnum enum module.
     * @module enum/PaymentAmountTypeEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>payment_amount_type</code> property.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "current_balance"
         * @const
         */
        "current_balance": "current_balance",
        /**
         * value: "minimum_payment_due"
         * @const
         */
        "minimum_payment_due": "minimum_payment_due",
        /**
         * value: "past_payment_due"
         * @const
         */
        "past_payment_due": "past_payment_due",
        /**
         * value: "statement_balance"
         * @const
         */
        "statement_balance": "statement_balance",
        /**
         * value: "discounted_amount"
         * @const
         */
        "discounted_amount": "discounted_amount",
        /**
         * value: "penalty_amount"
         * @const
         */
        "penalty_amount": "penalty_amount",
        /**
         * value: "other"
         * @const
         */
        "other": "other"
    });

    return exports;
}));