/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The RefundFilterEnum enum module.
     * @module enum/RefundFilterEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>key</code> property while retrieving refunds.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "id_customer"
         * @const
         */
        "id_customer": "id_customer",
        /**
         * value: "status"
         * @const
         */
        "status": "status",
        /**
         * value: "confirmation_number"
         * @const
         */
        "confirmation_number": "confirmation_number",
        /**
         * value: "from_date"
         * @const
         */
        "from_date": "from_date",
        /**
         * value: "to_date"
         * @const
         */
        "to_date": "to_date",
        /**
         * value: "page_size"
         * @const
         */
        "page_size": "page_size",
        /**
         * value: "query_id"
         * @const
         */
        "query_id": "query_id",
        /**
         * value: "from_index"
         * @const
         */
        "from_index": "from_index",
        /**
         * value: "to_index"
         * @const
         */
        "to_index": "to_index"
    });

    return exports;
}));