/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('logtown').getLogger('orbipay-paymentsapi-client/model/base/ResponseCode'));
    }
}(this, function (logger) {
    'use strict';


    /**
     * The Attribute model module.
     * @module model/base/ResponseCode
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>ResponseCode</code>.
     * @alias module:model/base/ResponseCode
     * @class
     */
    var exports = function (code, text) {
        var _this = this;
        _this['code'] = code;
        _this['text'] = text;
    };

    /**
     * @private
     * Constructs a <code>ResponseCode</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/base/ResponseCode} obj Optional instance to populate.
     * @return {module:model/base/ResponseCode} The populated <code>ResponseCode</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();
            if (data.hasOwnProperty('code')) {
                obj['code'] = data['code'];
            }
            if (data.hasOwnProperty('text')) {
                obj['text'] = data['text'];
            }
        }
        return obj;
    };

    /**
     * @member {String} code
     */
    exports.prototype['code'] = undefined;
    /**
     * @member {String} text
     */
    exports.prototype['text'] = undefined;


    return exports;
}));