/**
 * Created by Alacriti Inc on 2/7/19.
 */

(function (root, factory) {
  if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('logtown').getLogger('orbipay-paymentsapi-client/model/payment/PaymentNetworkResponse'));
  }
}(this, function (logger) {
  'use strict';




  /**
   * The PaymentNetworkResponse model module.
   * @module model/payment/PaymentNetworkResponse
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>PaymentNetworkResponse</code>.
   * The response received either from ACH or Card networks.
   * @alias module:model/payment/PaymentNetworkResponse
   * @class
   */
  var exports = function() {

  };

  /**
   * Constructs a <code>PaymentNetworkResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/payment/PaymentNetworkResponse} obj Optional instance to populate.
   * @return {module:model/payment/PaymentNetworkResponse} The populated <code>PaymentNetworkResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('payment_auth_code')) {
        obj['payment_auth_code'] = data['payment_auth_code'];
      }
      if (data.hasOwnProperty('payment_response_code')) {
        obj['payment_response_code'] = data['payment_response_code'];
      }
      if (data.hasOwnProperty('payment_response_msg')) {
        obj['payment_response_msg'] = data['payment_response_msg'];
      }
    }
    return obj;
  };

  /**
   * The Auth Code returned by the card gateway. This is relevant only for card payments.
   * @member {String} payment_auth_code
   */
  exports.prototype['payment_auth_code'] = undefined;
  /**
   * The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments. OR The decline codes received from the card issuer or the card processor, in the event of declined card payments.
   * @member {String} payment_response_code
   */
  exports.prototype['payment_response_code'] = undefined;
  /**
   * The text describing the ACH return or the chargeback received from Visa/Mastercard, in the event of returned payments. OR The text describing the decline, from the card issuer or the card processor, in the event of declined card payments.
   * @member {String} payment_response_msg
   */
  exports.prototype['payment_response_msg'] = undefined;



  return exports;
}));


