/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CustomerAccountResponse'), require('../model/CustomerAccountsResponse'), require('../model/ErrorResponseVO'));
    }
}(this, function (ApiClient, CustomerAccountResponse, CustomerAccountsResponse, ErrorResponseVO) {
    'use strict';

    /**
     * CustomerAccount service.
     * @module swagger/api/CustomerAccountApi
     * @version 1.0.0
     */

    /**
     * Constructs a new CustomerAccountApi.
     * @alias module:swagger/api/CustomerAccountApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the getCustomerAccount operation.
         * @callback module:swagger/api/CustomerAccountApi~getCustomerAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerAccountResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Customer Account
         * The Get Customer Account API is used to retrieve the details of a customer account based on the id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER_ACCOUNT The unique identifier assigned by Orbipay to the Customer Account.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/CustomerAccountApi~getCustomerAccountCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerAccountResponse}
         */
        this.getCustomerAccount = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER_ACCOUNT, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            // verify the required parameter 'channel' is set
            if (channel === undefined || channel === null) {
                throw new Error("Missing the required parameter 'channel' when calling getCustomerAccount");
            }

            // verify the required parameter 'clientKey' is set
            if (clientKey === undefined || clientKey === null) {
                throw new Error("Missing the required parameter 'clientKey' when calling getCustomerAccount");
            }

            // verify the required parameter 'product' is set
            if (product === undefined || product === null) {
                throw new Error("Missing the required parameter 'product' when calling getCustomerAccount");
            }

            // verify the required parameter 'timestamp' is set
            if (timestamp === undefined || timestamp === null) {
                throw new Error("Missing the required parameter 'timestamp' when calling getCustomerAccount");
            }

            // verify the required parameter 'idempotentRequestKey' is set
            if (idempotentRequestKey === undefined || idempotentRequestKey === null) {
                throw new Error("Missing the required parameter 'idempotentRequestKey' when calling getCustomerAccount");
            }

            // verify the required parameter 'requestor' is set
            if (requestor === undefined || requestor === null) {
                throw new Error("Missing the required parameter 'requestor' when calling getCustomerAccount");
            }

            // verify the required parameter 'requestorType' is set
            if (requestorType === undefined || requestorType === null) {
                throw new Error("Missing the required parameter 'requestorType' when calling getCustomerAccount");
            }

            // verify the required parameter 'ID_CUSTOMER_ACCOUNT' is set
            if (ID_CUSTOMER_ACCOUNT === undefined || ID_CUSTOMER_ACCOUNT === null) {
                throw new Error("Missing the required parameter 'ID_CUSTOMER_ACCOUNT' when calling getCustomerAccount");
            }

            // verify the required parameter 'ID_CUSTOMER' is set
            if (ID_CUSTOMER === undefined || ID_CUSTOMER === null) {
                throw new Error("Missing the required parameter 'ID_CUSTOMER' when calling getCustomerAccount");
            }


            var pathParams = {
                'ID_CUSTOMER_ACCOUNT': ID_CUSTOMER_ACCOUNT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = CustomerAccountResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveCustomerAccounts operation.
         * @callback module:swagger/api/CustomerAccountApi~retrieveCustomerAccountsCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerAccountsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Customer Accounts
         * The API is used to retrieve all the customer accounts associated with a customer. The accounts can be filtered using the account number, status.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.accountNumber The Account Number to get details of.
         * @param {String} opts.status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {module:swagger/api/CustomerAccountApi~retrieveCustomerAccountsCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerAccountsResponse}
         */
        this.retrieveCustomerAccounts = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            // verify the required parameter 'channel' is set
            if (channel === undefined || channel === null) {
                throw new Error("Missing the required parameter 'channel' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'clientKey' is set
            if (clientKey === undefined || clientKey === null) {
                throw new Error("Missing the required parameter 'clientKey' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'product' is set
            if (product === undefined || product === null) {
                throw new Error("Missing the required parameter 'product' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'timestamp' is set
            if (timestamp === undefined || timestamp === null) {
                throw new Error("Missing the required parameter 'timestamp' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'idempotentRequestKey' is set
            if (idempotentRequestKey === undefined || idempotentRequestKey === null) {
                throw new Error("Missing the required parameter 'idempotentRequestKey' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'requestor' is set
            if (requestor === undefined || requestor === null) {
                throw new Error("Missing the required parameter 'requestor' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'requestorType' is set
            if (requestorType === undefined || requestorType === null) {
                throw new Error("Missing the required parameter 'requestorType' when calling retrieveCustomerAccounts");
            }

            // verify the required parameter 'ID_CUSTOMER' is set
            if (ID_CUSTOMER === undefined || ID_CUSTOMER === null) {
                throw new Error("Missing the required parameter 'ID_CUSTOMER' when calling retrieveCustomerAccounts");
            }


            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
                'page_size': opts['pageSize']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
                'account_number': opts['accountNumber'],
                'status': opts['status']
            };

            var authNames = [];
            var contentTypes = ['application/x-www-form-urlencoded'];
            var accepts = ['application/json'];
            var returnType = CustomerAccountsResponse;

            console.log('OPTS ' + JSON.stringify(opts));
            console.log('FORM_PARAMS ' + JSON.stringify(formParams));

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/customeraccounts/lists', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveCustomerAccountsPage operation.
         * @callback module:swagger/api/CustomerAccountApi~retrieveCustomerAccountsPageCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerAccountsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Customer Accounts Page
         * This API is used to retrieve all the matching customer accounts associated with a customer.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {String} queryId query id of the Retrieve/Search Accounts lookup.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.toIndex To fetch the next set of objects that start after this object
         * @param {String} opts.fromIndex To fetch the previous set of objects that end at this object
         * @param {module:swagger/api/CustomerAccountApi~retrieveCustomerAccountsPageCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerAccountsResponse}
         */
        this.retrieveCustomerAccountsPage = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, queryId, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
                'page_size': opts['pageSize'],
                'query_id': queryId,
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = CustomerAccountsResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/customeraccounts/lists', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }
    };

    return exports;
}));
