/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CreateCustomerRequest'), require('../model/CustomerResponse'), require('../model/CustomersResponse'), require('../model/ErrorResponseVO'), require('../model/UpdateCustomerRequest'));
    }
}(this, function (ApiClient, CreateCustomerRequest, CustomerResponse, CustomersResponse, ErrorResponseVO, UpdateCustomerRequest) {
    'use strict';

    /**
     * Customer service.
     * @module swagger/api/CustomerApi
     * @version 1.0.0
     */

    /**
     * Constructs a new CustomerApi.
     * @alias module:swagger/api/CustomerApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the createCustomer operation.
         * @callback module:swagger/api/CustomerApi~createCustomerCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Create Customer
         * The Create Customer API is used to register a customer with a biller in Orbipay. It is also mandatory to create a customer account for the customer. So, at least one customer account should be provided in order to register a customer. There is no limit on the number of accounts that can be associated with the customer.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {module:swagger/model/CreateCustomerRequest} createCustomerRequest The JSON that contains all the attributes of customer to be created.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/CustomerApi~createCustomerCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerResponse}
         */
        this.createCustomer = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, createCustomerRequest, opts, callback) {
            opts = opts || {};
            var postBody = createCustomerRequest;

            var pathParams = {};
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = CustomerResponse;

            return this.apiClient.callApi(
                '/customers', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the getCustomer operation.
         * @callback module:swagger/api/CustomerApi~getCustomerCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Customer
         * The Get Customer API is used to retrieve the details of the customer based on the id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/CustomerApi~getCustomerCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerResponse}
         */
        this.getCustomer = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = CustomerResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveCustomers operation.
         * @callback module:swagger/api/CustomerApi~retrieveCustomersCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomersResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Customers
         * This API is used to retrieve/lookup customers from Orbipay. Customers can be retrieved matching criteria that includes the customer_reference, the ssn, the email or the customer account number.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.customerReference Unique ID assigned by the biller/client system for a given customer.
         * @param {String} opts.ssn The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.
         * @param {String} opts.email This field contains the customer’s email address within Orbipay.
         * @param {String} opts.accountNumber Customer Account Number of the customer to get details of.
         * @param {module:swagger/api/CustomerApi~retrieveCustomersCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomersResponse}
         */
        this.retrieveCustomers = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {};
            var queryParams = {
                'page_size': opts['pageSize']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
                'customer_reference': opts['customerReference'],
                'ssn': opts['ssn'],
                'email': opts['email'],
                'account_number': opts['accountNumber']
            };

            var authNames = [];
            var contentTypes = ['application/x-www-form-urlencoded'];
            var accepts = ['application/json'];
            var returnType = CustomersResponse;

            return this.apiClient.callApi(
                '/customers/lists', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveCustomersPage operation.
         * @callback module:swagger/api/CustomerApi~retrieveCustomersPageCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomersResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Customers Page
         * This API is used to get previous and next pages for a Customer lookup (Retrieve).
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} queryId query id of the Retrieve/Search Customers lookup.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.toIndex To fetch the next set of objects that start after this object
         * @param {String} opts.fromIndex To fetch the previous set of objects that end at this object
         * @param {module:swagger/api/CustomerApi~retrieveCustomersPageCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomersResponse}
         */
        this.retrieveCustomersPage = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, queryId, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {};
            var queryParams = {
                'page_size': opts['pageSize'],
                'query_id': queryId,
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = CustomersResponse;

            return this.apiClient.callApi(
                '/customers/lists', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the updateCustomer operation.
         * @callback module:swagger/api/CustomerApi~updateCustomerCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/CustomerResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Update Customer
         * The Update Customer API is used to edit the customer&#39;s personal details, accounts or the customer&#39;s status. Only the information being updated needs to be sent in the request, along with the id of the customer being updated. A customer can also be associated with new customer accounts using the API.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/UpdateCustomerRequest} updateCustomerRequest JSON containing all the attributes of the customer to be updated.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/CustomerApi~updateCustomerCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/CustomerResponse}
         */
        this.updateCustomer = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, updateCustomerRequest, opts, callback) {
            opts = opts || {};
            var postBody = updateCustomerRequest;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = CustomerResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}', 'PUT',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }
    };

    return exports;
}));
