/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/ErrorResponseVO'), require('../model/PaymentResponse'));
    }
}(this, function (ApiClient, ErrorResponseVO, PaymentResponse) {
    'use strict';

    /**
     * Payment service.
     * @module swagger/api/FeePaymentApi
     * @version 1.0.0
     */

    /**
     * Constructs a new FeePaymentApi.
     * @alias module:swagger/api/FeePaymentApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;

        /**
         * Callback function to receive the result of the getFeePayment operation.
         * @callback module:swagger/api/FeePaymentApi~getFeePaymentCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Payment
         * The API is used to retrieve the details of a fee payment by id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_FEE The unique identifier assigned by Orbipay to the fee payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FeePaymentApi~getFeePaymentCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentResponse}
         */
        this.getFeePayment = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_FEE, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_FEE': ID_FEE,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = PaymentResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fees/{ID_FEE}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };
    };

    return exports;
}));
