/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/AddFundingAccountRequest'), require('../model/DeleteFundingAccountRequest'), require('../model/DeleteResponse'), require('../model/ErrorResponseVO'), require('../model/FundingAccountResponse'), require('../model/FundingAccountsResponse'), require('../model/UpdateFundingAccountRequest'),  require('../model/ReplaceFundingAccountRequest'));
    }
}(this, function (ApiClient, AddFundingAccountRequest, DeleteFundingAccountRequest, DeleteResponse, ErrorResponseVO, FundingAccountResponse, FundingAccountsResponse, UpdateFundingAccountRequest, ReplaceFundingAccountRequest) {
    'use strict';

    /**
     * FundingAccount service.
     * @module swagger/api/FundingAccountApi
     * @version 1.0.0
     */

    /**
     * Constructs a new FundingAccountApi.
     * @alias module:swagger/api/FundingAccountApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the addFundingAccount operation.
         * @callback module:swagger/api/FundingAccountApi~addFundingAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Add Funding Account
         * This API is used to add a funding account for the customer. The funding account is available for servicing all the customer accounts the customer holds. An exhaustive set of account types are supported as funding accounts as indicated in the field account_subtype. ABA routing number and account sub-type are mandatory for bank accounts. Expiry date, address fields and Card CVV are required for card accounts.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/AddFundingAccountRequest} addFundingAccountRequest JSON containing all the attributes of the Funding account to be added to customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FundingAccountApi~addFundingAccountCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/FundingAccountResponse}
         */
        this.addFundingAccount = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, addFundingAccountRequest, opts, callback) {
            opts = opts || {};
            var postBody = addFundingAccountRequest;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = FundingAccountResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the deleteFundingAccount operation.
         * @callback module:swagger/api/FundingAccountApi~deleteFundingAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/DeleteResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Delete Funding Account
         * The Delete Funding Account API is used to delete the funding account of a customer. All pending payments made with that account are cancelled upon deletion of the funding account.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_FUNDING_ACCOUNT The unique identifier assigned by Orbipay to the Funding Account.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/DeleteFundingAccountRequest} deleteFundingAccountRequest Details of account to be deleted.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FundingAccountApi~deleteFundingAccountCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/DeleteResponse}
         */
        this.deleteFundingAccount = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_FUNDING_ACCOUNT, ID_CUSTOMER, deleteFundingAccountRequest, opts, callback) {
            opts = opts || {};
            var postBody = deleteFundingAccountRequest;

            var pathParams = {
                'ID_FUNDING_ACCOUNT': ID_FUNDING_ACCOUNT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = DeleteResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'DELETE',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the getFundingAccount operation.
         * @callback module:swagger/api/FundingAccountApi~getFundingAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Funding Account
         * The Get Funding Account API is used to retrieve the details of the funding account based on the id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_FUNDING_ACCOUNT The unique identifier assigned by Orbipay to the Funding Account.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FundingAccountApi~getFundingAccountCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/FundingAccountResponse}
         */
        this.getFundingAccount = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_FUNDING_ACCOUNT, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_FUNDING_ACCOUNT': ID_FUNDING_ACCOUNT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = FundingAccountResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveFundingAccounts operation.
         * @callback module:swagger/api/FundingAccountApi~retrieveFundingAccountsCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Funding Accounts
         * This API is used to retrieve all the funding accounts associated with a customer. Accounts can be filtered using the account number, the ABA routing number (for bank accounts), the account status, account type, account sub-type and others mentioned below.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.accountNumber The Account Number to get details of.
         * @param {String} opts.status The status of the funding account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.abaRoutingNumber The ABA/Routing number for the bank account.
         * @param {String} opts.accountType The type of the funding account. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.accountSubtype The sub type of the funding account. This is derived by Orbipay in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
         * @param {module:swagger/api/FundingAccountApi~retrieveFundingAccountsCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/FundingAccountsResponse}
         */
        this.retrieveFundingAccounts = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
                'page_size': opts['pageSize']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
                'account_number': opts['accountNumber'],
                'status': opts['status'],
                'aba_routing_number': opts['abaRoutingNumber'],
                'account_type': opts['accountType'],
                'account_subtype': opts['accountSubtype']
            };

            var authNames = [];
            var contentTypes = ['application/x-www-form-urlencoded'];
            var accepts = ['application/json'];
            var returnType = FundingAccountsResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrieveFundingAccountsPage operation.
         * @callback module:swagger/api/FundingAccountApi~retrieveFundingAccountsPageCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Funding Accounts Page
         * This API is used to get a page/set of funding accounts based on the lookup id,
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {String} queryId query id of the Retrieve/Search Accounts lookup.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String} opts.toIndex To fetch the next set of objects that start after this object
         * @param {String} opts.fromIndex To fetch the previous set of objects that end at this object
         * @param {module:swagger/api/FundingAccountApi~retrieveFundingAccountsPageCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/FundingAccountsResponse}
         */
        this.retrieveFundingAccountsPage = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, queryId, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
                'page_size': opts['pageSize'],
                'query_id': queryId,
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = FundingAccountsResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the updateFundingAccount operation.
         * @callback module:swagger/api/FundingAccountApi~updateFundingAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Update Funding Account
         * The API is used to edit the funding account details. The type of the funding account cannot be changed. In other words, a card account cannot be changed to a bank account and vice versa. The sub-type of a bank account can be changed. For e.g., a saving account can be updated to a money market account. However, the sub-type cannot be updated for a card account. CVV is mandatory to make any change to a card account. The Id of the funding account gets updated to a new value if the account number is updated. Editing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_FUNDING_ACCOUNT The unique identifier assigned by Orbipay to the Funding Account.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/UpdateFundingAccountRequest} updateFundingAccountRequest JSON containing all the attributes of the Funding account to be updated.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FundingAccountApi~updateFundingAccountCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/FundingAccountResponse}
         */
        this.updateFundingAccount = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_FUNDING_ACCOUNT, ID_CUSTOMER, updateFundingAccountRequest, opts, callback) {
            opts = opts || {};
            var postBody = updateFundingAccountRequest;

            var pathParams = {
                'ID_FUNDING_ACCOUNT': ID_FUNDING_ACCOUNT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = FundingAccountResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'PUT',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }

        /**
         * Callback function to receive the result of the replaceFundingAccount operation.
         * @callback module:swagger/api/FundingAccountApi~replaceFundingAccountCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/FundingAccountResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Replce Funding Account
         * The API is used to replace the funding account details. The type of the funding account cannot be replaced. In other words, a card account cannot be replaced to a bank account and vice versa. CVV is mandatory to make any change to a card account.Replacing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_FUNDING_ACCOUNT The unique identifier assigned by Orbipay to the Funding Account.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/ReplaceFundingAccountRequest} replaceFundingAccountRequest JSON containing all the attributes of the Funding account to be replaced.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/FundingAccountApi~replaceFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
         * data is of type: {@link module:swagger/model/FundingAccountResponse}
         */
        this.replaceFundingAccount = function(channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_FUNDING_ACCOUNT, ID_CUSTOMER, replaceFundingAccountRequest, opts, callback) {
            opts = opts || {};
            var postBody = replaceFundingAccountRequest;

            var pathParams = {
                'ID_FUNDING_ACCOUNT': ID_FUNDING_ACCOUNT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
            };
            var collectionQueryParams = {
            };
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
            };

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = FundingAccountResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}/replacement', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }

    };

    return exports;
}));
