/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CreatePaymentRequest'), require('../model/DeletePaymentRequest'), require('../model/DeleteResponse'), require('../model/ErrorResponseVO'), require('../model/PaymentResponse'), require('../model/PaymentsResponse'), require('../model/UpdatePaymentRequest'));
    }
}(this, function (ApiClient, CreatePaymentRequest, DeletePaymentRequest, DeleteResponse, ErrorResponseVO, PaymentResponse, PaymentsResponse, UpdatePaymentRequest) {
    'use strict';

    /**
     * Payment service.
     * @module swagger/api/PaymentApi
     * @version 1.0.0
     */

    /**
     * Constructs a new PaymentApi.
     * @alias module:swagger/api/PaymentApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the createPayment operation.
         * @callback module:swagger/api/PaymentApi~createPaymentCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Create Payment
         * The API is used to make payments to service a customer account. Client systems can provide the unique identifier for the payment in their system as payment_reference.&lt;p&gt;Fee amount and fee type are conditional and should be provided if the details of the fee to be charged are maintained in the client system. The fee types that are supported in Orbipay are add_to_principal and bill_separately. Alternatively, the fee information can be setup in Orbipay, in which case, these fields are ignored. If fee information is setup in the system, the details of the fee are returned in the response.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/CreatePaymentRequest} createPaymentRequest JSON containing all the fields required to make a payment.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentApi~createPaymentCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentResponse}
         */
        this.createPayment = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, createPaymentRequest, opts, callback) {
            opts = opts || {};
            var postBody = createPaymentRequest;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = PaymentResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the deletePayment operation.
         * @callback module:swagger/api/PaymentApi~deletePaymentCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/DeleteResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Delete Payment
         * The API is used to delete or cancel a payment. Payments that are under processing or have already been processed cannot be  deleted.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT The unique identifier assigned by Orbipay to the payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/DeletePaymentRequest} deletePaymentRequest Details of payment to be deleted/cancelled
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentApi~deletePaymentCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/DeleteResponse}
         */
        this.deletePayment = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT, ID_CUSTOMER, deletePaymentRequest, opts, callback) {
            opts = opts || {};
            var postBody = deletePaymentRequest;

            var pathParams = {
                'ID_PAYMENT': ID_PAYMENT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = DeleteResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments/{ID_PAYMENT}', 'DELETE',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the getFeePayment operation.
         * @callback module:swagger/api/PaymentApi~getPaymentCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Payment
         * The API is used to retrieve the details of a payment by id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT The unique identifier assigned by Orbipay to the payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentApi~getPaymentCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentResponse}
         */
        this.getFeePayment = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_PAYMENT': ID_PAYMENT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = PaymentResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments/{ID_PAYMENT}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrievePayments operation.
         * @callback module:swagger/api/PaymentApi~retrievePaymentsCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Payments
         * The API is used to retrieve the payments made by a customer. Payments can be filtered using the confirmation number, customer account, funding account, status and payment schedule type, by date range and others mentioned below. If no dates are provided for retrieval, payments in the last six months and all the payments scheduled for a future date are returned. In case a payment has failed due to ACH returns, then the payment return date and the return code will be available in the response.   If the requestor type is customer then the id_customer request parameter is mandatory.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.idCustomer The unique identifier assigned by Orbipay to the customer.
         * @param {String} opts.idFundingAccount The unique identifier assigned by Orbipay to the funding account
         * @param {String} opts.idCustomerAccount The unique identifier assigned by Orbipay to the customer account
         * @param {String} opts.confirmationNumber The confirmation number or reference provided to the customer for the successful payment.
         * @param {String} opts.status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.paymentScheduleType The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.fromDate The date from which payments, matching the criteria specified, need to be retrieved.
         * @param {String} opts.toDate The date upto which payments, matching the criteria specified, need to be retrieved.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String}  opts.queryId query id of the Retrieve/Search Accounts lookup.
         * @param {String} opts.toIndex To fetch the next set of objects that start after this object
         * @param {String} opts.fromIndex To fetch the previous set of objects that end at this object
         * @param {module:swagger/api/PaymentApi~retrievePaymentsCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentsResponse}
         */
        this.retrievePayments = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, opts, callback) {
            opts = opts || {};
            var postBody = null;
            var pathParams = {};
            var queryParams = {
                'id_customer': opts['idCustomer'],
                'id_funding_account': opts['idFundingAccount'],
                'id_customer_account': opts['idCustomerAccount'],
                'confirmation_number': opts['confirmationNumber'],
                'status': opts['status'],
                'payment_schedule_type': opts['paymentScheduleType'],
                'from_date': opts['fromDate'],
                'to_date': opts['toDate'],
                'page_size': opts['pageSize'],
                '_txn_pymnt_schld_type': opts['_txnPymntSchldType'],
                'query_id': opts['queryId'],
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = PaymentsResponse;

            return this.apiClient.callApi(
                '/payments', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the updatePayment operation.
         * @callback module:swagger/api/PaymentApi~updatePaymentCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Update Payment
         * The API is used to edit a payment. Only payments in scheduled status can be edited.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT The unique identifier assigned by Orbipay to the payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/UpdatePaymentRequest} updatePaymentRequest Details of the Payment to be updated.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentApi~updatePaymentCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentResponse}
         */
        this.updatePayment = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT, ID_CUSTOMER, updatePaymentRequest, opts, callback) {
            opts = opts || {};
            var postBody = updatePaymentRequest;

            var pathParams = {
                'ID_PAYMENT': ID_PAYMENT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = PaymentResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments/{ID_PAYMENT}', 'PUT',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }
    };

    return exports;
}));
