/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CreatePaymentSetupRequest'), require('../model/DeletePaymentSetupRequest'), require('../model/DeleteResponse'), require('../model/ErrorResponseVO'), require('../model/PaymentSetupResponse'), require('../model/PaymentSetupsResponse'));
    }
}(this, function (ApiClient, CreatePaymentSetupRequest, DeletePaymentSetupRequest, DeleteResponse, ErrorResponseVO, PaymentSetupResponse, PaymentSetupsResponse) {
    'use strict';

    /**
     * PaymentSetup service.
     * @module swagger/api/PaymentSetupApi
     * @version 1.0.0
     */

    /**
     * Constructs a new PaymentSetupApi.
     * @alias module:swagger/api/PaymentSetupApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the createRecurringPaymentSetup operation.
         * @callback module:swagger/api/PaymentSetupApi~createRecurringPaymentSetupCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentSetupResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Create Payment Setup
         * The API is used to set up recurring payments to service a customer account.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/CreatePaymentSetupRequest} createPaymentSetupRequest JSON containing all the fields required to create a recurring payment setup.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentSetupApi~createRecurringPaymentSetupCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentSetupResponse}
         */
        this.createRecurringPaymentSetup = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_CUSTOMER, createPaymentSetupRequest, opts, callback) {
            opts = opts || {};
            var postBody = createPaymentSetupRequest;

            var pathParams = {
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = PaymentSetupResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/paymentsetups', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the deletePaymentSetup operation.
         * @callback module:swagger/api/PaymentSetupApi~deletePaymentSetupCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/DeleteResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Delete Payment Setup
         * The API is used to delete or cancel a recurring payment setup. Cancelling a payment setup will also cancel all the pending and future payments under the setup.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT_SETUP The unique identifier assigned by Orbipay to the payment setup.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/DeletePaymentSetupRequest} deletePaymentSetupRequest JSON containing all the fields required to delete a payment. Setup.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentSetupApi~deletePaymentSetupCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/DeleteResponse}
         */
        this.deletePaymentSetup = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT_SETUP, ID_CUSTOMER, deletePaymentSetupRequest, opts, callback) {
            opts = opts || {};
            var postBody = deletePaymentSetupRequest;

            var pathParams = {
                'ID_PAYMENT_SETUP': ID_PAYMENT_SETUP,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = DeleteResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'DELETE',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the getPaymentSetup operation.
         * @callback module:swagger/api/PaymentSetupApi~getPaymentSetupCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentSetupResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Get Payment Setup
         * The API is used to retrieve the details of a recurring payment setup by id.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT_SETUP The unique identifier assigned by Orbipay to the payment setup.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentSetupApi~getPaymentSetupCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentSetupResponse}
         */
        this.getPaymentSetup = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT_SETUP, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_PAYMENT_SETUP': ID_PAYMENT_SETUP,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = PaymentSetupResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        };

        /**
         * Callback function to receive the result of the retrievePaymentSetups operation.
         * @callback module:swagger/api/PaymentSetupApi~retrievePaymentSetupsCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentSetupsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Payment Setups
         * The API is used to retrieve the recurring and autopay payments setup made against a customer account. The setup can be filtered using the confirmation number, customer account, funding account, status and payment setup schedule type, by date range and others mentioned below. If no dates are provided for retrieval, recurring payments set up in the last six months and all the ones in future are returned. If the requestor type is customer then the id_customer request parameter is mandatory.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.idCustomer The unique identifier assigned by Orbipay to the customer.
         * @param {String} opts.idFundingAccount The unique identifier assigned by Orbipay to the funding account
         * @param {String} opts.idCustomerAccount The unique identifier assigned by Orbipay to the customer account
         * @param {String} opts.confirmationNumber The confirmation number or reference provided to the customer for the successful payment.
         * @param {String} opts.status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.paymentSetupScheduleType The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
         * @param {String} opts.fromDate The date from which recurring payments setup, matching the criteria specified, need to be retrieved.
         * @param {String} opts.toDate The date upto which recurring payments setup, matching the criteria specified, need to be retrieved.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {String}  opts.queryId query id of the Retrieve/Search Accounts lookup.
         * @param {String} opts.toIndex To fetch the next set of objects that start after this object
         * @param {String} opts.fromIndex To fetch the previous set of objects that end at this object
         * @param {module:swagger/api/PaymentSetupApi~retrievePaymentSetupsCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/PaymentSetupsResponse}
         */
        this.retrievePaymentSetups = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {};
            var queryParams = {
                'id_customer': opts['idCustomer'],
                'id_funding_account': opts['idFundingAccount'],
                'id_customer_account': opts['idCustomerAccount'],
                'confirmation_number': opts['confirmationNumber'],
                'status': opts['status'],
                'payment_setup_schedule_type': opts['paymentSetupScheduleType'],
                'from_date': opts['fromDate'],
                'to_date': opts['toDate'],
                'page_size': opts['pageSize'],
                'query_id': opts['queryId'],
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = PaymentSetupsResponse;

            return this.apiClient.callApi(
                '/paymentsetups', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }

        /**
         * Callback function to receive the result of the updatePaymentSetup operation.
         * @callback module:swagger/api/PaymentSetupApi~updatePaymentSetupCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/PaymentSetupResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Update Payment Setup
         * The API is used to edit a payment Setup. Only autopay payment setup is edited.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT_SETUP The unique identifier assigned by Orbipay to the payment setup.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/UpdatePaymentSetupRequest} updatePaymentSetupRequest Details of the Payment Setup to be updated.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/PaymentSetupApi~updatePaymentSetupCallback} callback The callback function, accepting three arguments: error, data, response
         * data is of type: {@link module:swagger/model/PaymentSetupResponse}
         */
        this.updatePaymentSetup = function(channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT_SETUP, ID_CUSTOMER, updatePaymentSetupRequest, opts, callback) {
            opts = opts || {};
            var postBody = updatePaymentSetupRequest;

            var pathParams = {
                'ID_PAYMENT_SETUP': ID_PAYMENT_SETUP,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
            };
            var collectionQueryParams = {
            };
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
            };

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = PaymentSetupResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'PUT',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }

    };

    return exports;
}));
