/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CreateRefundRequest'), require('../model/ErrorResponseVO'), require('../model/RefundResponse'), require('../model/RefundsResponse'));
    }
}(this, function (ApiClient, CreateRefundRequest, ErrorResponseVO, RefundResponse, RefundsResponse) {
    'use strict';

    /**
     * Refund service.
     * @module swagger/api/RefundApi
     * @version 1.0.0
     */

    /**
     * Constructs a new RefundApi.
     * @alias module:swagger/api/RefundApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the createRefund operation.
         * @callback module:swagger/api/RefundApi~createRefundCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/RefundResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Create Refund
         * This API is used to initiate a refund. Any payment made using Orbipay can be refunded. Customer cannot initiate a refund request.  In other words, the Create Refund request will fail if the associated requestor_type is customer. The refund types that are supported in Orbipay are payment_and_fee, payment_only, fee_only, other. The amount is optional and needs to be specified only if it&#39;s a partial refund i.e., the refund type is other.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT The unique identifier assigned by Orbipay to the payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/CreateRefundRequest} createRefundRequest JSON containing all the fields required to refund a payment.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/RefundApi~createRefundCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/RefundResponse}
         */
        this.createRefund = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT, ID_CUSTOMER, createRefundRequest, opts, callback) {
            opts = opts || {};
            var postBody = createRefundRequest;

            var pathParams = {
                'ID_PAYMENT': ID_PAYMENT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = RefundResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments/{ID_PAYMENT}/refunds', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }

        /**
         * Get Refund
         * The API is used to retrieve the details of a refund by id.
         * @param {String} channel The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, <b>yyyy-MM-dd HH:mm:ss.SSSZ</b></br> For e.g., <i>2018-07-13 11:41:17.422+00:00</i>  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \"<a href=\"#duplicate-requests-&-retrials\">Duplicate Requests & Retrials</a>\" section for more details.
         * @param {String} requestorType If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \"customer\".</br> If an API is being requested from an application that is being used by an agent or a customer service representative belonging to the biller/client organization, then the requestor_type should be set to \"client_agent\". It should be noted that there should be a user in the EBPP Portal (or Payment Center) corresponding to this user.</br>If an API is being requested from an application that is being used by third party agents servicing a customer on behalf of a biller/client, then the requestor_type should be set to \"external_user\". It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.</br> If the requestor_type is \"customer\", the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to 'guest'.</br> If the requestor_type is \"client_agent\", the requestor should be the login id for the client agent user to the Orbipay EBPP Portal / Payment Center.</br> If the requestor_type is \"external_user\", the requestor can be any unique identifier that the client may have for the external agent.
         * @param {String} ID_REFUND The unique identifier assigned by Orbipay to the refund.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/RefundApi~getRefundCallback} callback The callback function, accepting three arguments: error, data, response
         * data is of type: {@link module:swagger/model/RefundResponse}
         */
        this.getRefund = function(channel, clientKey, product, timestamp, idempotentRequestKey, requestorType, requestor, ID_REFUND, ID_CUSTOMER, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
                'ID_REFUND': ID_REFUND,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {
            };
            var collectionQueryParams = {
            };
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor_type': requestorType,
                'requestor': requestor,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
            };

            var authNames = [];
            var contentTypes = [];
            var accepts = ['application/json'];
            var returnType = RefundResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/refunds/{ID_REFUND}', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }


        /**
         * Callback function to receive the result of the retrieveRefunds operation.
         * @callback module:api/RefundApi~retrieveRefundsCallback
         * @param {String} error Error message, if any.
         * @param {module:model/RefundsResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Retrieve Refunds
         * The API is used to retrieve the refunds made to a customer against payments processed through Orbipay. Refunds can be filtered using the customer id, confirmation number of the payment being refunded or of the refund, status of the refund and others mentioned below. Scheduled refunds that are yet to be processed and all the refunds processed in the last six months are returned if date criteria is not specified.   If the requestor_type is customer then the id_customer request parameter is mandatory.
         * @param {String} channel The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {module:model/String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, <b>yyyy-MM-dd HH:mm:ss.SSSZ</b></br> For e.g., <i>2018-07-13 11:41:17.422+00:00</i>  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \"<a href=\"#duplicate-requests-&-retrials\">Duplicate Requests & Retrials</a>\" section for more details.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client's external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to 'guest'.
         * @param {module:model/String} requestorType Type of the requestor of the API.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {String} opts.idCustomer The unique identifier assigned by Orbipay to the customer.
         * @param {String} opts.confirmationNumber The confirmation number provided to the customer for the refund or for the corresponding successful payment.
         * @param {module:model/String} opts.status The status of the refund. This can take multiple values in the format key=value1&key=value2....
         * @param {Date} opts.fromDate The date from which refunds, matching the criteria specified, need to be retrieved.
         * @param {Date} opts.toDate The date upto which refunds, matching the criteria specified, need to be retrieved.
         * @param {String} opts.pageSize The maximum number of objects returned in the query.
         * @param {module:api/RefundApi~retrieveRefundsCallback} callback The callback function, accepting three arguments: error, data, response
         * data is of type: {@link module:model/RefundsResponse}
         */
        this.retrieveRefunds = function(channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, opts, callback) {
            opts = opts || {};
            var postBody = null;

            var pathParams = {
            };
            var queryParams = {
                'id_customer': opts['idCustomer'],
                'confirmation_number': opts['confirmationNumber'],
                'status': opts['status'],
                'from_date': opts['fromDate'],
                'to_date': opts['toDate'],
                'page_size': opts['pageSize'],
                'query_id': opts['queryId'],
                'to_index': opts['toIndex'],
                'from_index': opts['fromIndex']
            };
            var collectionQueryParams = {
            };
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {
            };

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = RefundsResponse;

            return this.apiClient.callApi(
                '/refunds', 'GET',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }
     };

return exports;
}));
