/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'),require('./FeeRefundRequest'));
    }
}(this, function (ApiClient,FeeRefundRequest) {
    'use strict';


    /**
     * The CreateRefundRequest model module.
     * @module swagger/model/CreateRefundRequest
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>CreateRefundRequest</code>.
     * @alias module:swagger/model/CreateRefundRequest
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>CreateRefundRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/CreateRefundRequest} obj Optional instance to populate.
     * @return {module:swagger/model/CreateRefundRequest} The populated <code>CreateRefundRequest</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('refund_reference')) {
                obj['refund_reference'] = ApiClient.convertToType(data['refund_reference'], 'String');
            }
            if (data.hasOwnProperty('refund_amount')) {
                obj['refund_amount'] = ApiClient.convertToType(data['refund_amount'], 'String');
            }
            if (data.hasOwnProperty('comments')) {
                obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
            }
            if (data.hasOwnProperty('custom_fields')) {
                obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
            }
            if (data.hasOwnProperty('fee_refund')) {
                obj['fee_refund'] = FeeRefundRequest.constructFromObject(data['fee_refund']);
            }
        }
        return obj;
    };

    /**
     * The unique identifier in the client system for the refund.
     * @member {String} refund_reference
     */
    exports.prototype['refund_reference'] = undefined;

    exports.prototype['fee_refund'] = undefined;
    /**
     * The refund amount upto 2 decimal places.
     * @member {String} refund_amount
     */
    exports.prototype['refund_amount'] = undefined;
    /**
     * @member {String} comments
     */
    exports.prototype['comments'] = undefined;
    /**
     * The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact support@billerpayments.com for more information on configuring and using custom fields.
     * @member {Object} custom_fields
     */
    exports.prototype['custom_fields'] = undefined;


    return exports;
}));


