/*
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
 if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RefundResponse'));
  }
}(this, function(ApiClient, RefundResponse) {
  'use strict';

  /**
   * The RefundsResponse model module.
   * @module model/RefundsResponse
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>RefundsResponse</code>.
   * @alias module:model/RefundsResponse
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>RefundsResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RefundsResponse} obj Optional instance to populate.
   * @return {module:model/RefundsResponse} The populated <code>RefundsResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {

      obj = obj || new exports();

      if (data.hasOwnProperty('list')) {
          obj.list = ApiClient.convertToType(data['list'], [RefundResponse]);
      }
      if (data.hasOwnProperty('total_results_count')) {
          obj.total_results_count = ApiClient.convertToType(data['total_results_count'], 'String');
      }
      if (data.hasOwnProperty('has_more_results')) {
          obj.has_more_results = ApiClient.convertToType(data['has_more_results'], 'String');
      }
      if (data.hasOwnProperty('url')) {
          obj.url = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('from_index')) {
          obj.from_index = ApiClient.convertToType(data['from_index'], 'String');
      }
      if (data.hasOwnProperty('to_index')) {
          obj.to_index = ApiClient.convertToType(data['to_index'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {Array.<module:model/RefundResponse>} list
   */
  exports.prototype['list'] = undefined;
  /**
   * total number of payments available with matching criteria
   * @member {String} totalResultsCount
   */
  exports.prototype['total_results_count'] = undefined;

  /**
   * true if there are more results or pages
   * @member {module:model/RefundsResponse.HasMoreResultsEnum} hasMoreResults
   */
  exports.prototype['has_more_results'] = undefined;

  /**
   * This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;

  /**
   * The id of the object before which the previous set of objects are to be retrieved.
   * @member {String} fromIndex
   */
  exports.prototype['from_index'] = undefined;

  /**
   * The id of the object after which the next set of objects are to be retrieved.
   * @member {String} toIndex
   */
  exports.prototype['to_index'] = undefined;


  /**
   * Allowed values for the <code>hasMoreResults</code> property.
   * @enum {String}
   * @readonly
   */
  exports.HasMoreResultsEnum = {
    /**
     * value: "true"
     * @const
     */
    _true: "true",

    /**
     * value: "false"
     * @const
     */
    _false: "false"
  };

  return exports;

}));
