/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
   if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('./FundingAccountSnapshotResponse'), require('./SourcePaymentCustomer'), require('./SourcePaymentCustomerAccount'));
    }
}(this, function (ApiClient, FundingAccountSnapshotResponse, SourcePaymentCustomer, SourcePaymentCustomerAccount) {
    'use strict';


    /**
     * The SourcePayment model module.
     * @module swagger/model/SourcePayment
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>SourcePayment</code>.
     * @alias module:swagger/model/SourcePayment
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>SourcePayment</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/SourcePayment} obj Optional instance to populate.
     * @return {module:swagger/model/SourcePayment} The populated <code>SourcePayment</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('url')) {
                obj['url'] = ApiClient.convertToType(data['url'], 'String');
            }
            if (data.hasOwnProperty('customer')) {
                obj['customer'] = SourcePaymentCustomer.constructFromObject(data['customer']);
            }
            if (data.hasOwnProperty('customer_account')) {
                obj['customer_account'] = SourcePaymentCustomerAccount.constructFromObject(data['customer_account']);
            }
            if (data.hasOwnProperty('funding_account')) {
                obj['funding_account'] = FundingAccountSnapshotResponse.constructFromObject(data['funding_account']);
            }
        }
        return obj;
    };

    /**
     * @member {String} id
     */
    exports.prototype['id'] = undefined;
    /**
     * This URL fetches the details of payment.
     * @member {String} url
     */
    exports.prototype['url'] = undefined;

    /**
     * @member {module:swagger/model/SourcePaymentCustomer} customer
     */
    exports.prototype['customer'] = undefined;

    /**
     * @member {module:swagger/model/SourcePaymentCustomerAccount} customer_account
     */
    exports.prototype['customer_account'] = undefined;

    /**
     * @member {module:swagger/model/FundingAccountSnapshotResponse} funding_account
     */
    exports.prototype['funding_account'] = undefined;


    return exports;
}));


