/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('logtown').getLogger('orbipay-paymentsapi-client/util/ResponseWrapper'), require('./../constant/HttpParamConstants'), require('./../model/base/InvocationContext'), require('../exception/OrbipayApiException'));
    }
}(this, function (logger, HttpParamConstants, InvocationContext, OrbipayApiException) {
        'use strict';


        /**
         * The ResponseWrapper model module.
         * @module util/ResponseWrapper
         * @version 1.0.0
         */

        /**
         * Constructs a new <code>ResponseWrapper</code>.
         * @alias module:util/ResponseWrapper
         * @class
         */
        var exports = function () {
        };

        exports.wrapResponse = function (exportsFunction, exception, httpErrorMessage, httpParsedData, httpResponse, clientRequest) {
            var data;
            if (!exception) {
                if (!httpErrorMessage) {
                    data = exportsFunction.constructFromObject(httpParsedData);
                    data[HttpParamConstants.INVOCATION_CONTEXT] = httpResponse ? InvocationContext.constructFromHeaders(httpResponse['header']) : undefined;
                } else {
                    exception = OrbipayApiException.constructFromHttpResponse(httpErrorMessage, httpResponse, clientRequest);
                }
            }
            return {'exception': exception, 'data': data};
        };


        return exports;
    }
));
